Index: /palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- /palm/trunk/SOURCE/init_3d_model.f90	(revision 2231)
+++ /palm/trunk/SOURCE/init_3d_model.f90	(revision 2232)
@@ -20,5 +20,9 @@
 ! Current revisions:
 ! ------------------
-! 
+! Adjustments to new topography and surface concept: 
+!   - Modify passed parameters for disturb_field
+!   - Topography representation via flags
+!   - Remove unused arrays. 
+!   - Move initialization of surface-related quantities to surface_mod
 ! 
 ! Former revisions:
@@ -346,5 +350,5 @@
 
     USE land_surface_model_mod,                                                &
-        ONLY:  lsm_init, lsm_init_arrays, land_surface
+        ONLY:  lsm_init, lsm_init_arrays
   
     USE ls_forcing_mod
@@ -383,4 +387,8 @@
     USE surface_layer_fluxes_mod,                                              &
         ONLY:  init_surface_layer_fluxes
+
+    USE surface_mod,                                                           &
+        ONLY :  init_surface_arrays, init_surfaces, surf_def_h, surf_lsm_h,    &
+                surf_usm_h
    
     USE transpose_indices
@@ -398,5 +406,7 @@
     INTEGER(iwp) ::  j             !<
     INTEGER(iwp) ::  k             !<
-    INTEGER(iwp) ::  sr            !<
+    INTEGER(iwp) ::  k_surf        !< surface level index
+    INTEGER(iwp) ::  m             !< index of surface element in surface data type
+    INTEGER(iwp) ::  sr            !< index of statistic region
 
     INTEGER(iwp), DIMENSION(:), ALLOCATABLE   ::  ngp_2dh_l  !<
@@ -447,11 +457,4 @@
               ts_value(dots_max,0:statistic_regions) )
     ALLOCATE( ptdf_x(nxlg:nxrg), ptdf_y(nysg:nyng) )
-
-    ALLOCATE( ol(nysg:nyng,nxlg:nxrg), shf(nysg:nyng,nxlg:nxrg),               &
-              ts(nysg:nyng,nxlg:nxrg), tswst(nysg:nyng,nxlg:nxrg),             &
-              us(nysg:nyng,nxlg:nxrg), usws(nysg:nyng,nxlg:nxrg),              &
-              uswst(nysg:nyng,nxlg:nxrg), vsws(nysg:nyng,nxlg:nxrg),           &
-              vswst(nysg:nyng,nxlg:nxrg), z0(nysg:nyng,nxlg:nxrg),             &
-              z0h(nysg:nyng,nxlg:nxrg), z0q(nysg:nyng,nxlg:nxrg) )
 
     ALLOCATE( d(nzb+1:nzt,nys:nyn,nxl:nxr),                                    &
@@ -519,10 +522,4 @@
     IF ( humidity )  THEN
 !
-!--    2D-humidity
-       ALLOCATE ( qs(nysg:nyng,nxlg:nxrg),                                     &
-                  qsws(nysg:nyng,nxlg:nxrg),                                   &
-                  qswst(nysg:nyng,nxlg:nxrg) )
-
-!
 !--    3D-humidity
 #if defined( __nopointer )
@@ -571,12 +568,4 @@
 
              IF ( microphysics_seifert )  THEN
-!
-!--             2D-rain water content and rain drop concentration arrays
-                ALLOCATE ( qrs(nysg:nyng,nxlg:nxrg),                        &
-                           qrsws(nysg:nyng,nxlg:nxrg),                      &
-                           qrswst(nysg:nyng,nxlg:nxrg),                     &
-                           nrs(nysg:nyng,nxlg:nxrg),                        &
-                           nrsws(nysg:nyng,nxlg:nxrg),                      &
-                           nrswst(nysg:nyng,nxlg:nxrg) )
 !
 !--             3D-rain water content, rain drop concentration arrays
@@ -622,9 +611,4 @@
     
     IF ( passive_scalar )  THEN
-!
-!--    2D-scalar arrays
-       ALLOCATE ( ss(nysg:nyng,nxlg:nxrg),                                     &
-                  ssws(nysg:nyng,nxlg:nxrg),                                   &
-                  sswst(nysg:nyng,nxlg:nxrg) )
 
 !
@@ -642,6 +626,4 @@
 
     IF ( ocean )  THEN
-       ALLOCATE( saswsb(nysg:nyng,nxlg:nxrg),                                  &
-                 saswst(nysg:nyng,nxlg:nxrg) )
 #if defined( __nopointer )
        ALLOCATE( prho(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                          &
@@ -660,8 +642,4 @@
                       ! density to be apointer
 #endif
-       IF ( humidity_remote )  THEN
-          ALLOCATE( qswst_remote(nysg:nyng,nxlg:nxrg))
-          qswst_remote = 0.0_wp
-       ENDIF
     ENDIF
 
@@ -818,11 +796,4 @@
 
 !
-!-- 4D-array for storing the Rif-values at vertical walls
-    IF ( topography /= 'flat' )  THEN
-       ALLOCATE( rif_wall(nzb:nzt+1,nysg:nyng,nxlg:nxrg,1:4) )
-       rif_wall = 0.0_wp
-    ENDIF
-
-!
 !-- Arrays to store velocity data from t-dt and the phase speeds which
 !-- are needed for radiation boundary conditions
@@ -901,5 +872,7 @@
     ENDIF
 #endif
-
+!
+!-- Initialize wall arrays
+    CALL init_surface_arrays
 !
 !-- Allocate land surface model arrays
@@ -944,5 +917,4 @@
     sums_up_fraction_l = 0.0_wp
     sums_wsts_bc_l     = 0.0_wp
-
 
 !
@@ -1007,45 +979,7 @@
              hom(:,1,25,:) = SPREAD( l1d, 2, statistic_regions+1 )
 
-             IF ( constant_flux_layer )  THEN
-                ol   = ( zu(nzb+1) - zw(nzb) ) / ( rif1d(nzb+1) + 1.0E-20_wp )
-                ts   = 0.0_wp  ! could actually be computed more accurately in the
-                               ! 1D model. Update when opportunity arises.
-                us   = us1d
-                usws = usws1d
-                vsws = vsws1d
-             ELSE
-                ts   = 0.0_wp  ! must be set, because used in
-                ol   = ( zu(nzb+1) - zw(nzb) ) / zeta_min  ! flowste
-                us   = 0.0_wp
-                usws = 0.0_wp
-                vsws = 0.0_wp
-             ENDIF
-
           ELSE
              e    = 0.0_wp  ! must be set, because used in
-             ol   = ( zu(nzb+1) - zw(nzb) ) / zeta_min  ! flowste
-             ts   = 0.0_wp
-             us   = 0.0_wp
-             usws = 0.0_wp
-             vsws = 0.0_wp
-          ENDIF
-          uswst = top_momentumflux_u * momentumflux_input_conversion(nzt+1)
-          vswst = top_momentumflux_v * momentumflux_input_conversion(nzt+1)
-
-!
-!--       In every case qs = 0.0 (see also pt)
-!--       This could actually be computed more accurately in the 1D model.
-!--       Update when opportunity arises!
-          IF ( humidity )  THEN
-             qs = 0.0_wp
-             IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-                qrs = 0.0_wp
-                nrs = 0.0_wp
-             ENDIF
-          ENDIF
-!
-!--       Initialize scaling parameter for passive scalar
-          IF ( passive_scalar ) ss = 0.0_wp          
-
+          ENDIF
 !
 !--       Inside buildings set velocities back to zero
@@ -1053,6 +987,10 @@
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
-                   u(nzb:nzb_u_inner(j,i),j,i) = 0.0_wp
-                   v(nzb:nzb_v_inner(j,i),j,i) = 0.0_wp
+                   DO  k = nzb, nzt
+                      u(k,j,i) = MERGE( u(k,j,i), 0.0_wp,                      &
+                                        BTEST( wall_flags_0(k,j,i), 1 ) )
+                      v(k,j,i) = MERGE( v(k,j,i), 0.0_wp,                      &
+                                        BTEST( wall_flags_0(k,j,i), 2 ) )
+                   ENDDO
                 ENDDO
              ENDDO
@@ -1070,6 +1008,6 @@
                 DO  i = nxl-1, nxr+1
                    DO  j = nys-1, nyn+1
-                      IF ( nzb_u_inner(j,i) == 0 ) u(0,j,i) = u(1,j,i)
-                      IF ( nzb_v_inner(j,i) == 0 ) v(0,j,i) = v(1,j,i)
+                      u(nzb,j,i) = u(nzb+1,j,i)
+                      v(nzb,j,i) = v(nzb+1,j,i)
                    ENDDO
                 ENDDO
@@ -1119,6 +1057,10 @@
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
-                   u(nzb:nzb_u_inner(j,i)+1,j,i) = 0.0_wp
-                   v(nzb:nzb_v_inner(j,i)+1,j,i) = 0.0_wp
+                   DO  k = nzb, nzt
+                      u(k,j,i) = MERGE( u(k,j,i), 0.0_wp,                      &
+                                        BTEST( wall_flags_0(k,j,i), 20 ) )
+                      v(k,j,i) = MERGE( v(k,j,i), 0.0_wp,                      &
+                                        BTEST( wall_flags_0(k,j,i), 21 ) )
+                   ENDDO
                 ENDDO
              ENDDO
@@ -1183,17 +1125,4 @@
              e    = 0.0_wp
           ENDIF
-          ol    = ( zu(nzb+1) - zw(nzb) ) / zeta_min
-          ts    = 0.0_wp
-!
-!--       Very small number is required for calculation of Obukhov length 
-!--       at first timestep     
-          us    = 1E-30_wp 
-          usws  = 0.0_wp
-          uswst = top_momentumflux_u * momentumflux_input_conversion(nzt+1)
-          vsws  = 0.0_wp
-          vswst = top_momentumflux_v * momentumflux_input_conversion(nzt+1)
-          IF ( humidity )       qs = 0.0_wp
-          IF ( passive_scalar ) ss = 0.0_wp
-
 !
 !--       Compute initial temperature field and other constants used in case
@@ -1282,149 +1211,4 @@
           CALL init_parallel_random_generator(nx, ny, nys, nyn, nxl, nxr)
        ENDIF
-
-!
-!--    Initialize fluxes at bottom surface
-       IF ( use_surface_fluxes )  THEN
-
-          IF ( constant_heatflux )  THEN
-!
-!--          Heat flux is prescribed
-             IF ( random_heatflux )  THEN
-                CALL disturb_heatflux
-             ELSE
-                shf = surface_heatflux * heatflux_input_conversion(nzb)
-!
-!--             Initialize shf with data from external file LSF_DATA
-                IF ( large_scale_forcing .AND. lsf_surf )  THEN
-                   CALL ls_forcing_surf ( simulated_time )
-                ENDIF
-
-!
-!--             Over topography surface_heatflux is replaced by wall_heatflux(0)
-                IF ( TRIM( topography ) /= 'flat' )  THEN
-                   DO  i = nxlg, nxrg
-                      DO  j = nysg, nyng
-                         IF ( nzb_s_inner(j,i) /= 0 )  THEN
-                            shf(j,i) = wall_heatflux(0)                        &
-                                  * heatflux_input_conversion(nzb_s_inner(j,i))
-                         ENDIF
-                      ENDDO
-                   ENDDO
-                ENDIF
-             ENDIF
-          ENDIF
-
-!
-!--       Determine the near-surface water flux
-          IF ( humidity )  THEN
-             IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-                qrsws = 0.0_wp
-                nrsws = 0.0_wp
-             ENDIF
-             IF ( constant_waterflux )  THEN
-                qsws   = surface_waterflux * waterflux_input_conversion(nzb)
-!
-!--             Over topography surface_waterflux is replaced by 
-!--             wall_humidityflux(0)
-                IF ( TRIM( topography ) /= 'flat' )  THEN
-                   wall_qflux = wall_humidityflux
-                   DO  i = nxlg, nxrg
-                      DO  j = nysg, nyng
-                         IF ( nzb_s_inner(j,i) /= 0 )  THEN
-                            qsws(j,i) = wall_qflux(0)                          &
-                                 * waterflux_input_conversion(nzb_s_inner(j,i))
-                         ENDIF
-                      ENDDO
-                   ENDDO
-                ENDIF
-             ENDIF
-          ENDIF
-!
-!--       Initialize the near-surface scalar flux
-          IF ( passive_scalar )  THEN
-             IF ( constant_scalarflux )  THEN
-                ssws   = surface_scalarflux
-!
-!--             Over topography surface_scalarflux is replaced by 
-!--             wall_scalarflux(0)
-                IF ( TRIM( topography ) /= 'flat' )  THEN
-                   wall_sflux = wall_scalarflux
-                   DO  i = nxlg, nxrg
-                      DO  j = nysg, nyng
-                         IF ( nzb_s_inner(j,i) /= 0 )  ssws(j,i) = wall_sflux(0)
-                      ENDDO
-                   ENDDO
-                ENDIF
-             ENDIF
-          ENDIF    
-!
-!--       Initialize near-surface salinity flux
-          IF ( ocean )  saswsb = bottom_salinityflux
-
-       ENDIF
-
-!
-!--    Initialize fluxes at top surface
-!--    Currently, only the heatflux and salinity flux can be prescribed.
-!--    The latent flux is zero in this case!
-       IF ( use_top_fluxes )  THEN
-!
-!--       Prescribe to heat flux
-          IF ( constant_top_heatflux )  tswst = top_heatflux                   &
-                                             * heatflux_input_conversion(nzt+1)
-!
-!--       Prescribe zero latent flux at the top      
-          IF ( humidity )  THEN
-             qswst = 0.0_wp
-             IF ( cloud_physics  .AND.  microphysics_seifert ) THEN
-                nrswst = 0.0_wp
-                qrswst = 0.0_wp
-             ENDIF
-          ENDIF
-!
-!--       Prescribe top scalar flux
-          IF ( passive_scalar .AND. constant_top_scalarflux )                  &
-             sswst = top_scalarflux
-!
-!--       Prescribe top salinity flux
-          IF ( ocean .AND. constant_top_salinityflux)                          &
-             saswst = top_salinityflux
-!
-!--       Initialization in case of a coupled model run
-          IF ( coupling_mode == 'ocean_to_atmosphere' )  THEN
-             tswst = 0.0_wp
-          ENDIF
-
-       ENDIF
-
-!
-!--    Initialize Prandtl layer quantities
-       IF ( constant_flux_layer )  THEN
-
-          z0 = roughness_length
-          z0h = z0h_factor * z0
-          z0q = z0h_factor * z0
-
-          IF ( .NOT. constant_heatflux )  THEN 
-!
-!--          Surface temperature is prescribed. Here the heat flux cannot be
-!--          simply estimated, because therefore ol, u* and theta* would have
-!--          to be computed by iteration. This is why the heat flux is assumed
-!--          to be zero before the first time step. It approaches its correct
-!--          value in the course of the first few time steps.
-             shf   = 0.0_wp
-          ENDIF
-
-          IF ( humidity  )  THEN
-             IF (  .NOT.  constant_waterflux )  qsws   = 0.0_wp
-             IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-                qrsws = 0.0_wp
-                nrsws = 0.0_wp
-             ENDIF
-          ENDIF
-          IF ( passive_scalar  .AND.  .NOT.  constant_scalarflux )  ssws = 0.0_wp
-
-       ENDIF
-
 !
 !--    Set the reference state to be used in the buoyancy terms (for ocean runs
@@ -1522,9 +1306,16 @@
 
     ELSEIF ( TRIM( initializing_actions ) == 'read_restart_data'  .OR.         &
-         TRIM( initializing_actions ) == 'cyclic_fill' )                       &
+             TRIM( initializing_actions ) == 'cyclic_fill' )                   &
     THEN
 
        CALL location_message( 'initializing in case of restart / cyclic_fill', &
                               .FALSE. )
+!
+!--    Initialize surface elements and its attributes, e.g. heat- and 
+!--    momentumfluxes, roughness, scaling parameters. As number of surface 
+!--    elements might be different between runs, e.g. in case of cyclic fill, 
+!--    and not all surface elements are read, surface elements need to be 
+!--    initialized before.     
+       CALL init_surfaces
 !
 !--    When reading data for cyclic fill of 3D prerun data files, read
@@ -1671,13 +1462,24 @@
           DO  i = nxlg, nxrg
              DO  j = nysg, nyng
-                u  (nzb:nzb_u_inner(j,i),j,i)   = 0.0_wp
-                v  (nzb:nzb_v_inner(j,i),j,i)   = 0.0_wp
-                w  (nzb:nzb_w_inner(j,i),j,i)   = 0.0_wp
-                e  (nzb:nzb_w_inner(j,i),j,i)   = 0.0_wp
-                tu_m(nzb:nzb_u_inner(j,i),j,i)  = 0.0_wp
-                tv_m(nzb:nzb_v_inner(j,i),j,i)  = 0.0_wp
-                tw_m(nzb:nzb_w_inner(j,i),j,i)  = 0.0_wp
-                te_m(nzb:nzb_w_inner(j,i),j,i)  = 0.0_wp
-                tpt_m(nzb:nzb_w_inner(j,i),j,i) = 0.0_wp
+                DO  k = nzb, nzt
+                   u(k,j,i)     = MERGE( u(k,j,i), 0.0_wp,                     &
+                                         BTEST( wall_flags_0(k,j,i), 1 ) )
+                   v(k,j,i)     = MERGE( v(k,j,i), 0.0_wp,                     &
+                                         BTEST( wall_flags_0(k,j,i), 2 ) )
+                   w(k,j,i)     = MERGE( w(k,j,i), 0.0_wp,                     &
+                                         BTEST( wall_flags_0(k,j,i), 3 ) )
+                   e(k,j,i)     = MERGE( e(k,j,i), 0.0_wp,                     &
+                                         BTEST( wall_flags_0(k,j,i), 0 ) )
+                   tu_m(k,j,i)  = MERGE( tu_m(k,j,i), 0.0_wp,                  &
+                                         BTEST( wall_flags_0(k,j,i), 1 ) )
+                   tv_m(k,j,i)  = MERGE( tv_m(k,j,i), 0.0_wp,                  &
+                                         BTEST( wall_flags_0(k,j,i), 2 ) )
+                   tw_m(k,j,i)  = MERGE( tw_m(k,j,i), 0.0_wp,                  &
+                                         BTEST( wall_flags_0(k,j,i), 3 ) )
+                   te_m(k,j,i)  = MERGE( te_m(k,j,i), 0.0_wp,                  &
+                                         BTEST( wall_flags_0(k,j,i), 0 ) )
+                   tpt_m(k,j,i) = MERGE( tpt_m(k,j,i), 0.0_wp,                 &
+                                         BTEST( wall_flags_0(k,j,i), 0 ) )
+                ENDDO
              ENDDO
           ENDDO
@@ -1766,8 +1568,15 @@
           IF ( nxr == nx )  THEN
              DO  j = nys, nyn
-                DO  k = nzb_u_inner(j,nx)+1, nzt
+                DO  k = nzb+1, nzt
                    volume_flow_initial_l(1) = volume_flow_initial_l(1) +       &
-                                              u_init(k) * dzw(k)
-                   volume_flow_area_l(1)    = volume_flow_area_l(1) + dzw(k)
+                                              u_init(k) * dzw(k)               &
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,j,nxr), 1 )&
+                                            )
+
+                   volume_flow_area_l(1)    = volume_flow_area_l(1) + dzw(k)   &
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,j,nxr), 1 )&
+                                            )
                 ENDDO
              ENDDO
@@ -1776,8 +1585,14 @@
           IF ( nyn == ny )  THEN
              DO  i = nxl, nxr
-                DO  k = nzb_v_inner(ny,i)+1, nzt
-                   volume_flow_initial_l(2) = volume_flow_initial_l(2) + &
-                                              v_init(k) * dzw(k)
-                   volume_flow_area_l(2)    = volume_flow_area_l(2) + dzw(k)
+                DO  k = nzb+1, nzt
+                   volume_flow_initial_l(2) = volume_flow_initial_l(2) +       &
+                                              v_init(k) * dzw(k)               &        
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,nyn,i), 2 )&
+                                            )
+                   volume_flow_area_l(2)    = volume_flow_area_l(2) + dzw(k)   &        
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,nyn,i), 2 )&
+                                            )
                 ENDDO
              ENDDO
@@ -1802,8 +1617,14 @@
           IF ( nxr == nx )  THEN
              DO  j = nys, nyn
-                DO  k = nzb_u_inner(j,nx)+1, nzt
+                DO  k = nzb+1, nzt
                    volume_flow_initial_l(1) = volume_flow_initial_l(1) +       &
-                                              hom_sum(k,1,0) * dzw(k)
-                   volume_flow_area_l(1)    = volume_flow_area_l(1) + dzw(k)
+                                              hom_sum(k,1,0) * dzw(k)          &
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,j,nx), 1 ) &
+                                            )
+                   volume_flow_area_l(1)    = volume_flow_area_l(1) + dzw(k)   &
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,j,nx), 1 ) &
+                                            )
                 ENDDO
              ENDDO
@@ -1812,8 +1633,14 @@
           IF ( nyn == ny )  THEN
              DO  i = nxl, nxr
-                DO  k = nzb_v_inner(ny,i)+1, nzt
+                DO  k = nzb+1, nzt
                    volume_flow_initial_l(2) = volume_flow_initial_l(2) +       &
-                                              hom_sum(k,2,0) * dzw(k)
-                   volume_flow_area_l(2)    = volume_flow_area_l(2) + dzw(k)
+                                              hom_sum(k,2,0) * dzw(k)          &        
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,ny,i), 2 ) &
+                                            )
+                   volume_flow_area_l(2)    = volume_flow_area_l(2) + dzw(k)   &        
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,ny,i), 2 ) &
+                                            )
                 ENDDO
              ENDDO
@@ -1838,8 +1665,14 @@
           IF ( nxr == nx )  THEN
              DO  j = nys, nyn
-                DO  k = nzb_u_inner(j,nx)+1, nzt
-                   volume_flow_initial_l(1) = volume_flow_initial_l(1) + &
-                                              u(k,j,nx) * dzw(k)
-                   volume_flow_area_l(1)    = volume_flow_area_l(1) + dzw(k)
+                DO  k = nzb+1, nzt
+                   volume_flow_initial_l(1) = volume_flow_initial_l(1) +       &
+                                              u(k,j,nx) * dzw(k)               &
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,j,nx), 1 ) &
+                                            )
+                   volume_flow_area_l(1)    = volume_flow_area_l(1) + dzw(k)   &
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,j,nx), 1 ) &
+                                            )
                 ENDDO
              ENDDO
@@ -1848,8 +1681,14 @@
           IF ( nyn == ny )  THEN
              DO  i = nxl, nxr
-                DO  k = nzb_v_inner(ny,i)+1, nzt
+                DO  k = nzb+1, nzt
                    volume_flow_initial_l(2) = volume_flow_initial_l(2) +       &
-                                              v(k,ny,i) * dzw(k)
-                   volume_flow_area_l(2)    = volume_flow_area_l(2) + dzw(k)
+                                              v(k,ny,i) * dzw(k)               &        
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,ny,i), 2 ) &
+                                            )
+                   volume_flow_area_l(2)    = volume_flow_area_l(2) + dzw(k)   &        
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,ny,i), 2 ) &
+                                            )
                 ENDDO
              ENDDO
@@ -1878,5 +1717,34 @@
 
     ENDIF
-
+!
+!-- Initialize surface elements and its attributes, e.g. heat- and 
+!-- momentumfluxes, roughness, scaling parameters. 
+!-- This is already done in case of restart data.  
+    IF ( TRIM( initializing_actions ) /= 'read_restart_data'  .AND.            &
+         TRIM( initializing_actions ) /= 'cyclic_fill' )  THEN
+       CALL init_surfaces
+!
+!--    Finally, if random_heatflux is set, disturb shf at horizontal
+!--    surfaces. Actually, this should be done in surface_mod, where all other 
+!--    initializations of surface quantities are done. However, this
+!--    would create a ring dependency, hence, it is done here. Maybe delete
+!--    disturb_heatflux and tranfer the respective code directly into the 
+!--    initialization in surface_mod.         
+       IF ( use_surface_fluxes  .AND.  constant_heatflux  .AND.                &
+            random_heatflux )  THEN
+          IF ( surf_def_h(0)%ns >= 1 )  CALL disturb_heatflux( surf_def_h(0) )
+          IF ( surf_lsm_h%ns    >= 1 )  CALL disturb_heatflux( surf_lsm_h    )
+          IF ( surf_usm_h%ns    >= 1 )  CALL disturb_heatflux( surf_usm_h    )
+       ENDIF
+    ENDIF
+
+!
+!-- Initialize surface forcing corresponding to large-scale forcing. Therein, 
+!-- initialize heat-fluxes, etc. via datatype. Revise it later!
+    IF ( large_scale_forcing .AND. lsf_surf )  THEN
+       IF ( use_surface_fluxes  .AND.  constant_heatflux )  THEN
+          CALL ls_forcing_surf ( simulated_time )
+       ENDIF
+    ENDIF
 !
 !-- Initialize quantities for special advections schemes
@@ -1891,6 +1759,6 @@
 
        CALL location_message( 'creating initial disturbances', .FALSE. )
-       CALL disturb_field( nzb_u_inner, tend, u )
-       CALL disturb_field( nzb_v_inner, tend, v )
+       CALL disturb_field( 'u', tend, u )
+       CALL disturb_field( 'v', tend, v )
        CALL location_message( 'finished', .TRUE. )
 
@@ -2148,4 +2016,6 @@
     mean_surface_level_height_l = 0.0_wp
 
+!
+!-- To do: New concept for these non-topography grid points!
     DO  sr = 0, statistic_regions
        DO  i = nxl, nxr
@@ -2155,18 +2025,48 @@
 !--             All xy-grid points
                 ngp_2dh_l(sr) = ngp_2dh_l(sr) + 1
-                mean_surface_level_height_l(sr) = mean_surface_level_height_l(sr) &
-                                                  + zw(nzb_s_inner(j,i))
-!
-!--             xy-grid points above topography
-                DO  k = nzb_s_outer(j,i), nz + 1
-                   ngp_2dh_outer_l(k,sr) = ngp_2dh_outer_l(k,sr) + 1
+!
+!--             Determine mean surface-level height. In case of downward-
+!--             facing walls are present, more than one surface level exist.
+!--             In this case, use the lowest surface-level height. 
+                IF ( surf_def_h(0)%start_index(j,i) <=                         &
+                     surf_def_h(0)%end_index(j,i) )  THEN
+                   m = surf_def_h(0)%start_index(j,i)
+                   k = surf_def_h(0)%k(m)
+                   mean_surface_level_height_l(sr) =                           &
+                                       mean_surface_level_height_l(sr) + zw(k-1)
+                ENDIF
+                IF ( surf_lsm_h%start_index(j,i) <=                            &
+                     surf_lsm_h%end_index(j,i) )  THEN
+                   m = surf_lsm_h%start_index(j,i)
+                   k = surf_lsm_h%k(m)
+                   mean_surface_level_height_l(sr) =                           &
+                                       mean_surface_level_height_l(sr) + zw(k-1)
+                ENDIF
+                IF ( surf_usm_h%start_index(j,i) <=                            &
+                     surf_usm_h%end_index(j,i) )  THEN
+                   m = surf_usm_h%start_index(j,i)
+                   k = surf_usm_h%k(m)
+                   mean_surface_level_height_l(sr) =                           &
+                                       mean_surface_level_height_l(sr) + zw(k-1)
+                ENDIF
+
+                k_surf = k - 1
+
+                DO  k = nzb, nzt+1
+!
+!--                xy-grid points above topography
+                   ngp_2dh_outer_l(k,sr) = ngp_2dh_outer_l(k,sr)     +         &
+                                  MERGE( 1, 0, BTEST( wall_flags_0(k,j,i), 24 ) )
+
+                   ngp_2dh_s_inner_l(k,sr) = ngp_2dh_s_inner_l(k,sr) +         &
+                                  MERGE( 1, 0, BTEST( wall_flags_0(k,j,i), 22 ) )
+
                 ENDDO
-                DO  k = nzb_s_inner(j,i), nz + 1
-                   ngp_2dh_s_inner_l(k,sr) = ngp_2dh_s_inner_l(k,sr) + 1
-                ENDDO
 !
 !--             All grid points of the total domain above topography
-                ngp_3d_inner_l(sr) = ngp_3d_inner_l(sr)                        &
-                                     + ( nz - nzb_s_inner(j,i) + 2 )
+                ngp_3d_inner_l(sr) = ngp_3d_inner_l(sr) + ( nz - k_surf + 2 )
+
+
+
              ENDIF
           ENDDO
